<?php

namespace DrupalCodeBuilder\Generator;

/**
 * Generator for PHP interface files.
 *
 * TODO: extending from class file is hacky and will cause problems if we
 * expect too much of this.
 */
class PHPInterfaceFile extends PHPClassFile {

  /**
   * {@inheritdoc}
   */
  public static function componentDataDefinition() {
    $definition = parent::componentDataDefinition();

    // Remove properties that are not relevant.
    unset($definition['abstract']);
    unset($definition['interfaces']);
    unset($definition['parent_class_name']);

    $definition['parent_interface_names'] = [
      'label' => 'Parent interface names',
      'format' => 'array',
      'internal' => TRUE,
      'default' => [],
    ];

    return $definition;
  }

  /**
   * Produces the interface declaration.
   */
  function class_declaration() {
    $line = '';
    $line .= "interface $this->plain_class_name";
    if ($this->component_data['parent_interface_names']) {
      $line .= ' extends';
      foreach ($this->component_data['parent_interface_names'] as $interface_name) {
        $line .= ' ' . $interface_name;
      }
    }
    $line .= ' {';

    return [
      $line,
    ];
  }

}
